import { ProjectSearchService } from '../services/projectSearchService.js'
import { sendError } from '../utils/response.js'
// import { OftenError } from '../utils/oftenError.js'
import { GeneralService } from '../share/generalservice.js';
import { trim_all_array } from '../utils/trim.js'
import { verifyToken, generateToken } from '../utils/token.js'

export class projectSearch {

  constructor() {
    this.generalService = new GeneralService();
    this.projectSearchService = new ProjectSearchService();
  }

  async onNavigate(req, res) {
    this.generalService.devhint(1, 'projectSearch.js', 'onNavigate() start');
    let organization = req.body.organization;
    const prommis = await this.onProjectSearch(req, res, organization);
    return prommis;
  }

  async onProjectSearch(req, res, database) {
    let idx = -1
    let aryResult = []
    let condition = {}
    try {
      let token = req.headers.authorization?.split(' ')[1];
      const decoded = verifyToken(token);

      database = decoded.organization
      let columnParams = req.query.column
      var column = ""
      if(columnParams == 'edit'){
        column = `prjnam, prjwntbdg`
        condition['prjseq'] = req.body.request.prjseq
      } else if(columnParams == 'result' || columnParams == undefined || columnParams == ''){
        column = `prjseq, prjnam, prjwntbdg, prjacpbdg, ${database}.translatebdg(prjbdgcod) as prbdgnam, ${database}.translatedtl('COMSTT', prjcomstt) as prjcomstt, prjacpdtm`
      }

       aryResult = await this.projectSearchService.getProjectSearch(database, column, condition);

    } catch (error) {
      idx = 1;
    } finally { 
    if (idx === 1) return sendError('เกิดข้อผิดพลาดไม่คาดคิดเกิดขึ้น', 'Unexpected error');
    if (aryResult == 0) return sendError('ไม่พบการมีอยู่ของข้อมูล', 'Cannot Find Any Data');
    return aryResult
    }
  }
}
